#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <dirent.h>

#define clusterdir "/proc/hpc/nodes"
#define PI 3.14159
#define CNT 20000000

int cpucount() { 
	DIR *dirhpc; 
	struct dirent *dir_info; 
	int howmany=0; 
	int cpus=0; 
	FILE *fp; 
	char tmpdirname[200]; 
	char tmpfilename[200]; 
	strcpy(tmpdirname, ""); 
	if ((dirhpc=opendir(clusterdir))!=NULL) { 
		while ((dir_info = readdir(dirhpc))!=NULL) { 
			strcpy(tmpdirname, dir_info->d_name); 
			strcpy(tmpfilename, "/proc/hpc/nodes/"); 
			strcat(tmpfilename, tmpdirname); 
			strcat(tmpfilename, "/cpus"); 
			if (!strchr(tmpdirname, '.')) { 
				fp=fopen(tmpfilename, "r"); 
				if (fp) { 
					fscanf(fp, "%d", &cpus); 
					if(cpus>0) { 
						howmany=howmany+cpus; 
					} 
					fclose(fp); 
				} 
			} 
		} 
		closedir(dirhpc); 
//		printf("%d\n", howmany); 
		return howmany; 
	} 
} 



int main()
{
	int child,iter,i,j, h;
	float *ret;
	float *ret1;
	char buf[1024];
	float res=0;
	int processes=0;
	
	processes=cpucount();
	printf("starting %d forkit instances\n", processes);
   
	iter = CNT;
	
	if ((ret=malloc(iter*sizeof(float)))==NULL) printf("NO MEM!\n");
   
	for(i=0; i<processes; i++) {
		if ((ret=malloc(iter*sizeof(float)))==NULL) printf("NO MEM!\n");
		if ((child = fork()) == -1) perror("fork");
   		else if (!child) {     
			printf ("Proc %i started.\n",i);
			for(j=0;j<iter;j++) {
				ret[j]=sin(PI/2)/cos(0)*sin(PI/2);
			}
			exit(0);
   		}
		free(ret);
	} 

 // start another calculation to wait for finish
 printf ("Proc %i started.\n",i);
 if ((ret1=malloc(iter*sizeof(float)))==NULL) printf("NO MEM!\n");
 for(h=0;h<iter;h++) {
  ret1[h]=sin(PI/2)/cos(0)*sin(PI/2);
 }
						
return 0;
}


