#!/bin/bash

# this script makes the process PID move
# around your openMosix cluster


# set the commandline parameter

# first parameter : PID of the process to migrate
case "$1" in
    [0-9]*)
    PROC=$1
    ;;

    *)
    echo $"Usage: $0 [PID_to_migrate]"
    exit -1
esac


echo "running migrate-loop on process $PROC"

while (true)
 do

 for n in `ls /proc/hpc/nodes/`
  do

  let "TMP=`cat /proc/hpc/nodes/$n/cpus`"
  if (( $TMP!="-101" ));
   then
   migrate $PROC $n
   echo "migrated $PROC to node $n"
   sleep 60
  fi

 done

done;

# never reached ;)
echo "finished"




